#ifndef MYHEADER_H
#define MYHEADER_H

#include <ultra64.h>

typedef enum {
	TEXTURE_FMT_RGBA16,
	TEXTURE_FMT_RGBA32,
} TextureFormat;

typedef struct {
	u16		width;
	u16		height;
	void*		pixels;
	TextureFormat	fmt;
} Texture;

typedef struct Vector3f {
	float	x;
	float	y;
	float	z;
} Vector3f;

typedef struct {
	Vector3f	color;
	Texture*	tex;
} Material;

typedef struct {
	Material* mat;
	Gfx* gfx;
} Pair;

#endif	/* MYHEADER_H */

