#include <stdlib.h>
#include "block.h"

void blockHeaderConstruct(BlockHeader* bheader, uint32_t id, char* ordinal) {
	bheader->id = id;
	bheader->ordinal = ordinal;
}

void blockHeaderDestroy(BlockHeader* bheader) {
	free(bheader->ordinal);
}

Block* blockNew(BlockHeader* bheader) {
	Block* block;
	if(NULL == (block = malloc(sizeof(Block))))
		abort();
	blockConstruct(block, bheader);
	return block;
}

void blockDelete(Block* block) {
	blockDestroy(block);
	free(block);
}

void blockConstruct(Block* block, BlockHeader* bheader) {
	block->head = *bheader;
}

void blockDestroy(Block* block) {
	blockHeaderDestroy(&block->head);
}

inline uint32_t blockGetClipId(const Block* block) {
	return block->imag.clip_id;
}
