#ifndef BLOCK_H
#define BLOCK_H

#include <stdint.h>
#include "vector.h"

typedef struct {
	uint32_t	id;
	char*		ordinal;
} BlockHeader;

typedef struct {
	struct {
		Vector3f	vec;
		uint32_t	envel;
	} cntr, size;

	uint32_t	imag;
	char*		vmap;
} BlockTMAP;

typedef struct {
	uint32_t	clip_id;
} BlockIMAG;

typedef struct {
	BlockHeader	head;
	BlockTMAP	tmap;
	BlockIMAG	imag;
} Block;

typedef Block* PBlock;

/* interface */
void blockHeaderConstruct(BlockHeader* bheader, uint32_t id, char* ordinal);
void blockHeaderDestroy(BlockHeader* bheader);

Block* blockNew(BlockHeader* bheader);
void blockDelete(Block* block);
void blockConstruct(Block* block, BlockHeader* bheader);
void blockDestroy(Block* block);
uint32_t blockGetClipId(const Block* block);

#endif /* BLOCK_H */

