#include <stdlib.h>
#include <malloc.h>
#include "clip.h"

Clip* clipNew(uint32_t index, char* name) {
	Clip* clip = malloc(sizeof(Clip));
	if(NULL == clip)
		abort();
	clipConstruct(clip, index, name);
	return clip;
}

void clipDelete(Clip* clip) {
	clipDestroy(clip);
	free(clip);
}

void clipConstruct(Clip* clip, uint32_t index, char* name) {
	clip->index = index;
	clip->name = name;
}

void clipDestroy(Clip* clip) {
	free(clip->name);
}

uint32_t clipGetId(const Clip* clip) {
	return clip->index;
}
