#include <assert.h>
#include "face.h"

inline void faceConstruct(Face* face, uint16_t nids) {
	face->nids = nids;
}

inline void faceSetIndex(Face* face, uint32_t index, uint16_t value) {
	face->ids[index] = value;
}

inline uint16_t faceGetVertexCount(const Face* face) {
	return face->nids;
}

inline uint32_t faceGetIndex(const Face* face, uint16_t i) {
	return face->ids[i];
}

inline Vector2f* faceGetTexcoords(Face* face, uint16_t i) {
	return &face->tc[i];
}

bool faceRefersTo(const Face* face, uint32_t index) {
	for(uint16_t i=0, n=faceGetVertexCount(face); i<n; i++) {
		if(faceGetIndex(face, i) == index)
			return true;
	}

	return false;
}

