#ifndef FACE_H
#define FACE_H

#include <stdint.h>
#include <stdbool.h>
#include "vector.h"

#define	FACE_MAX_VTS	4			/*  */

typedef struct {
	uint32_t	ids[FACE_MAX_VTS];
	Vector2f	tc[FACE_MAX_VTS];
	Vector3f	col;
	uint16_t	nids;
} Face;

typedef Face* PFace;

/* interface */
void faceConstruct(Face* face, uint16_t nids);
void faceSetIndex(Face* face, uint32_t index, uint16_t value);
uint16_t faceGetVertexCount(const Face* face);
uint32_t faceGetIndex(const Face* face, uint16_t i);
Vector2f* faceGetTexcoords(Face* face, uint16_t i);
bool faceRefersTo(const Face* face, uint32_t index);

#endif

