#include <stdlib.h>
#include <malloc.h>
#include "hash.h"

Hash* hashNew(void) {
	Hash* hash = malloc(sizeof(Hash));
	if(NULL == hash)
		abort();
	hashConstruct(hash);
	return hash;
}

void hashDelete(Hash* hash) {
	hashDestroy(hash);
	free(hash);
}

void hashConstruct(Hash* hash) {
	vecConstruct(PMyPair, &hash->pairs);
}

void hashDestroy(Hash* hash) {
	for(uint32_t i=0; i<hashGetNumKeys(hash); i++) {
		mypairDelete(hashGetPair(hash, i));
	}
	vecDestroy(PMyPair, &hash->pairs);
}

void hashInsert(Hash* hash, uint32_t key, uint32_t value) {
	MyPair* pair = NULL;
	for(uint32_t i=0, n=vecGetSize(PMyPair, &hash->pairs); i<n; i++) {
		pair = *vecGetElement(PMyPair, &hash->pairs, i);
		if(key == pair->key)
			break;
		pair = NULL;
	}

	if(NULL == pair) {
		/* didn't find desired key - insert it */
		MyPair* newpair = mypairNew(key);
		vecPushBack(PMyPair, &hash->pairs, newpair);
		pair = newpair;
	}

	vecPushBack(uint32_t, &pair->vals, value);
}

inline uint32_t hashGetNumKeys(Hash* hash) {
	return vecGetSize(PMyPair, &hash->pairs);
}
/* 
const Vec(uint32_t)* hashGetByKey(Hash* hash, const uint32_t key) {
	uint32_t n = hashGetNumKeys(hash);
	for(uint32_t i=0; i<n; i++) {
		MyPair* pair = *vecGetElement(PMyPair, &hash->pairs, i);
		if(key == pair->key)
			return &pair->vals;
	}

	return NULL;
}
*/
inline MyPair* hashGetPair(Hash* hash, uint32_t i) {
	return *vecGetElement(PMyPair, &hash->pairs, i);
}
