#ifndef IMAGE_H
#define IMAGE_H

#include <stdint.h>
#include <stdbool.h>

typedef enum {
	IMAGE_FMT_CI4,
	IMAGE_FMT_RGBA16,
	IMAGE_FMT_RGBA32,
} ImageFormat;

typedef struct {
	ImageFormat	format;
	uint16_t	width;
	uint16_t	height;
	void*		pixels;
	uint16_t*	palette;
} Image;

/* interface */
Image* imageNew(const char* file);
void imageDelete(Image* image);
bool imageConstruct(Image* image, const char* file);
void imageDestroy(Image* image);
uint32_t imageGetPixelCount(const Image* image);
uint32_t imageGetPixel(const Image* image, uint32_t i);
void imageConvert(Image* image, ImageFormat format);

#endif	/* IMAGE_H */

