#ifndef LAYER__H
#define LAYER__H

#include <stdint.h>
#include "vec_.h"

typedef struct {
	Vec_		vts;
	Vec_		faces;
} Layer_;

/* interface */
void layer_Construct(Layer_* layer, uint32_t vts_el_size, uint32_t faces_el_size);
void layer_Destroy(Layer_* layer);

uint32_t layer_GetVertexCount(const Layer_* layer);
uint32_t layer_GetFaceCount(const Layer_* layer);

void* layer_GetVertex(Layer_* layer, uint32_t i);
void* layer_GetFace(Layer_* layer, uint32_t i);
const void* layer_GetConstVertex(const Layer_* layer, uint32_t i);
const void* layer_GetConstFace(const Layer_* layer, uint32_t i);

void layer_AddVertex(Layer_* layer, const void* vertex);
void layer_AddFace(Layer_* layer, const void* face);

#endif	/* LAYER__H */
