#ifndef LWOPARSER_H
#define LWOPARSER_H

#include <stdint.h>
#include <stdbool.h>
#include "mesh.h"

typedef struct {
	Mesh		mesh;
} LwoParser;

typedef struct {
	LwoParser*	parser;
	const void**	inbuf;
	uint32_t	bytes;
	uint32_t*	parentbytes;
	bool		issubchunk;
	void*		data;
	uint16_t	layer_number;

	uint32_t	bytesafter;
	uint32_t	id;
	uint32_t	size;
	Layer*		layer;
} ChunkContext;

/* interface */
void lwoparserConstruct(LwoParser* parser);
void lwoparserDestroy(LwoParser* parser);
bool ReadChunks(ChunkContext* ctx);
bool ParseLWO(LwoParser* parser, const uint32_t* inbuf, uint32_t filesize);

#endif	/* LWOPARSER_H */

