#include "math.h"

void mathCrossProduct(Vector3f* result, const Vector3f* u, const Vector3f* v) {
	vector3fSet(result, (u->y*v->z) - (u->z*v->y),
		  	    (u->z*v->x) - (u->x*v->z),
			    (u->x*v->y) - (u->y*v->x));
}

void mathNormalizeVector(Vector3f* result, const Vector3f* vector) {
	float length = vector3fCalcLength(vector);
	vector3fSet(result, (vector->x / length), (vector->y / length), (vector->z / length));
}

