#include <stdlib.h>
#include <malloc.h>
#include "mypair.h"

MyPair* mypairNew(uint32_t key) {
	MyPair* mypair = malloc(sizeof(MyPair));
	if(NULL == mypair)
		abort();
	mypairConstruct(mypair, key);
	return mypair;
}

void mypairDelete(MyPair* pair) {
	mypairDestroy(pair);
	free(pair);
}

void mypairConstruct(MyPair* pair, uint32_t key) {
	pair->key = key;
	vecConstruct(uint32_t, &pair->vals);
}

inline void mypairDestroy(MyPair* pair) {
	vecDestroy(uint32_t, &pair->vals);
}

