#ifndef SURFACE_H
#define SURFACE_H

#include <malloc.h>
#include "vector.h"
#include "vec_pblock.h"

typedef struct {
	char*		name;
	char*		source;
	Vector3f	color;
	Vec(PBlock)	blocks;
} Surface;

typedef Surface* PSurface;

/* interface */
Surface* surfaceNew(char* name, char* source, const Vector3f* color);
void surfaceDelete(Surface* surface);
void surfaceConstruct(Surface* surface, char* name, char* source, const Vector3f* color);
void surfaceDestroy(Surface* surface);
void surfaceSetName(Surface* surface, char* name);
void surfaceSetSource(Surface* surface, char* source);
void surfaceSetColor(Surface* surface, const Vector3f* color);

uint32_t surfaceGetBlockCount(const Surface* surface);

const char* surfaceGetName(const Surface* surface);
Vector3f* surfaceGetColor(Surface* surface);
const Vector3f* surfaceGetConstColor(const Surface* surface);
const Block* surfaceGetConstBlock(const Surface* surface, uint32_t i);

void surfaceAddBlock(Surface* surface, Block* block);

#endif	/* SURFACE_H */

