#ifndef ULTRALAYER_H
#define ULTRALAYER_H

#include "layer_.h"
#include "ultravertex.h"
#include "ultraface.h"

typedef struct {
	Layer_		layer_;
	uint16_t	matid;
} UltraLayer;

typedef UltraLayer* PUltraLayer;

/* interface */
UltraLayer* ultralayerNew(uint16_t matid);
void ultralayerDelete(UltraLayer* ulayer);
void ultralayerConstruct(UltraLayer* ulayer, uint16_t matid);
void ultralayerDestroy(UltraLayer* ulayer);

uint32_t ultralayerGetVertexCount(const UltraLayer* ulayer);
uint32_t ultralayerGetFaceCount(const UltraLayer* ulayer);
uint16_t ultralayerGetMaterialId(const UltraLayer* ulayer);

UltraVertex* ultralayerGetVertex(UltraLayer* ulayer, uint32_t i);
UltraFace* ultralayerGetFace(UltraLayer* ulayer, uint32_t i);
const UltraVertex* ultralayerGetConstVertex(const UltraLayer* ulayer, uint32_t i);
const UltraFace* ultralayerGetConstFace(const UltraLayer* ulayer, uint32_t i);

void ultralayerAddVertex(UltraLayer* ulayer, const UltraVertex* vertex);
void ultralayerAddFace(UltraLayer* ulayer, const UltraFace* face);

#endif	/* ULTRALAYER_H */
