#ifndef ULTRAMESH_H
#define ULTRAMESH_H

#include <stdint.h>
#include "ultralayer.h"
#include "ultramaterial.h"
#include "image.h"

typedef struct {
	Vec_	layers;
	Vec_	materials;
	Vec_	textures;
} UltraMesh;

/* interface */
UltraMesh* ultrameshNew(void);
void ultrameshDelete(UltraMesh* umesh);

void ultrameshConstruct(UltraMesh* umesh);
void ultrameshDestroy(UltraMesh* umesh);

uint16_t ultrameshGetLayerCount(const UltraMesh* umesh);
uint16_t ultrameshGetMaterialCount(const UltraMesh* umesh);
uint16_t ultrameshGetTextureCount(const UltraMesh* umesh);

UltraLayer* ultrameshGetLayer(UltraMesh* umesh, uint16_t i);
uint16_t ultrameshGetTexture(const UltraMesh* umesh, uint16_t i);
const UltraLayer* ultrameshGetConstLayer(const UltraMesh* umesh, uint16_t i);
const UltraMaterial* ultrameshGetConstMaterial(const UltraMesh* umesh, uint16_t i);
//const Image* ultrameshGetConstTexture(const UltraMesh* umesh, uint16_t i);

void ultrameshAddLayer(UltraMesh* umesh, const UltraLayer* layer);
void ultrameshAddMaterial(UltraMesh* umesh, const UltraMaterial* material);
void ultrameshAddTexture(UltraMesh* umesh, uint16_t texid);

char* ultrameshGenerateDL(const UltraMesh* umesh);

#endif	/* ULTRAMESH_H */

