#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "vec.h"

#ifdef T

inline Vec(T)* vecNew(T) {
	Vec(T)* vec = malloc(sizeof(Vec(T)));
	if(NULL == vec)
		abort();
	return vec;
}

inline void vecDelete(T, Vec(T)* vec) {
	vecDestroy(T, vec);
	free(vec);
}

void vecConstruct(T, Vec(T)* vec) {
	vec->num_el = 0;
	vec->max_el = 8;
	if( NULL == (vec->data = malloc(sizeof(T)*vec->max_el))) {
		abort();
	}
}

inline void vecDestroy(T, Vec(T)* vec) {
	free(vec->data);
}

void vecResize(T, Vec(T)* vec) {
	uint32_t newsize = vec->max_el << 1;

	if( NULL == (vec->data = realloc(vec->data, sizeof(T)*newsize))) {
		abort();
	}
	vec->max_el = newsize;
}

inline void vecPushBack(T, Vec(T)* vec, T element) {
	if(vec->num_el >= vec->max_el)
		vecResize(T, vec);

	vec->data[vec->num_el] = element;
	vec->num_el++;
}

inline T* vecGetElement(T, Vec(T)* vec, uint32_t i) {
	return &vec->data[i];
}

inline const T* vecGetConstElement(T, const Vec(T)* vec, uint32_t i) {
	return &vec->data[i];
}

inline uint32_t vecGetSize(T, const Vec(T)* vec) {
	return vec->num_el;
}

#endif

