#ifndef VEC__H
#define VEC__H

#include <stdint.h>

typedef struct {
	uint32_t	num_el;
	uint32_t	max_el;
	uint32_t	el_size;
	void*		data;
	void*		end;
} Vec_;

/* interface */
Vec_* vec_New(uint32_t el_size);
void vec_Delete(Vec_* vec);
void vec_Construct(Vec_* vec, uint32_t el_size);
void vec_Destroy(Vec_* vec);
void vec_Resize(Vec_* vec);
void vec_PushBack(Vec_* vec, const void* element);
void* vec_GetElement(Vec_* vec, uint32_t i);
const void* vec_GetConstElement(const Vec_* vec, uint32_t i);
uint32_t vec_GetSize(const Vec_* vec);

#endif	/* VEC__H */
