#include <math.h>
#include "vector.h"

inline void vector2fSet(Vector2f* vector, float x, float y) {
	vector->x = x;
	vector->y = y;
}

inline void vector3fSet(Vector3f* vector, float x, float y, float z) {
	vector->x = x;
	vector->y = y;
	vector->z = z;
}

inline float vector3fCalcLength(const Vector3f* vector) {
	return sqrt(vector->x*vector->x + vector->y*vector->y + vector->z*vector->z);
}

inline void vector3fAdd(Vector3f* result, const Vector3f* u, const Vector3f* v) {
	result->x = u->x + v->x;
	result->y = u->y + v->y;
	result->z = u->z + v->z;
}

inline void vector3fSub(Vector3f* result, const Vector3f* u, const Vector3f* v) {
	result->x = u->x - v->x;
	result->y = u->y - v->y;
	result->z = u->z - v->z;
}

inline void vector3fScaleUniform(Vector3f* result, float scale) {
	result->x = scale*result->x;
	result->y = scale*result->y;
	result->z = scale*result->z;
}

