#ifndef VECTOR_H
#define VECTOR_H

typedef struct Vector2f {
	float	x;
	float	y;
} Vector2f;

typedef struct Vector3f {
	float	x;
	float	y;
	float	z;
} Vector3f;

/* interface */
void vector2fSet(Vector2f* vector, float x, float y);

void vector3fSet(Vector3f* vector, float x, float y, float z);
float vector3fCalcLength(const Vector3f* vector);
void vector3fAdd(Vector3f* result, const Vector3f* u, const Vector3f* v);
void vector3fSub(Vector3f* result, const Vector3f* u, const Vector3f* v);
void vector3fScaleUniform(Vector3f* result, float scale);

#endif	/* VECTOR_H */

