#ifndef VERTEX_H
#define VERTEX_H

#include "vector.h"

typedef struct {
	Vector3f	pos;
	Vector3f	norm;
	Vector2f	tc;
} Vertex;

typedef Vertex* PVertex;

/* interface */
Vector3f* vertexGetPosition(Vertex* vertex);
Vector3f* vertexGetNormal(Vertex* vertex);
Vector2f* vertexGetTexCoords(Vertex* vertex);
const Vector3f* vertexGetConstPosition(const Vertex* vertex);
const Vector3f* vertexGetConstNormal(const Vertex* vertex);
const Vector2f* vertexGetConstTexCoords(const Vertex* vertex);

#endif	/* VERTEX_H */

